Skip to content
v2.273.0

CfnFirewall L1 construct ​

Use the firewall to provide stateful, managed, network firewall and intrusion detection and prevention filtering for your VPCs in Amazon VPC .

The firewall defines the configuration settings for an AWS Network Firewall firewall. The settings include the firewall policy, the subnets in your VPC to use for the firewall endpoints, and any tags that are attached to the firewall AWS resource.

Example ​

ts
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
import { aws_networkfirewall as networkfirewall } from 'aws-cdk-lib';
const cfnFirewall = new networkfirewall.CfnFirewall(this, 'MyCfnFirewall', {
  firewallName: 'firewallName',
  firewallPolicyArn: 'firewallPolicyArn',

  // the properties below are optional
  availabilityZoneChangeProtection: false,
  availabilityZoneMappings: [{
    availabilityZone: 'availabilityZone',
  }],
  deleteProtection: false,
  description: 'description',
  enabledAnalysisTypes: ['enabledAnalysisTypes'],
  firewallPolicyChangeProtection: false,
  subnetChangeProtection: false,
  subnetMappings: [{
    subnetId: 'subnetId',

    // the properties below are optional
    ipAddressType: 'ipAddressType',
  }],
  tags: [{
    key: 'key',
    value: 'value',
  }],
  transitGatewayId: 'transitGatewayId',
  vpcId: 'vpcId',
});
python
from aws_cdk import CfnTag
# The code below shows an example of how to instantiate this type.
# The values are placeholders you should change.
from aws_cdk import aws_networkfirewall as networkfirewall

cfn_firewall = networkfirewall.CfnFirewall(self, "MyCfnFirewall",
    firewall_name="firewallName",
    firewall_policy_arn="firewallPolicyArn",

    # the properties below are optional
    availability_zone_change_protection=False,
    availability_zone_mappings=[networkfirewall.CfnFirewall.AvailabilityZoneMappingProperty(
        availability_zone="availabilityZone"
    )],
    delete_protection=False,
    description="description",
    enabled_analysis_types=["enabledAnalysisTypes"],
    firewall_policy_change_protection=False,
    subnet_change_protection=False,
    subnet_mappings=[networkfirewall.CfnFirewall.SubnetMappingProperty(
        subnet_id="subnetId",

        # the properties below are optional
        ip_address_type="ipAddressType"
    )],
    tags=[CfnTag(
        key="key",
        value="value"
    )],
    transit_gateway_id="transitGatewayId",
    vpc_id="vpcId"
)
java
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
import software.amazon.awscdk.services.networkfirewall.*;

CfnFirewall cfnFirewall = CfnFirewall.Builder.create(this, "MyCfnFirewall")
        .firewallName("firewallName")
        .firewallPolicyArn("firewallPolicyArn")

        // the properties below are optional
        .availabilityZoneChangeProtection(false)
        .availabilityZoneMappings(List.of(AvailabilityZoneMappingProperty.builder()
                .availabilityZone("availabilityZone")
                .build()))
        .deleteProtection(false)
        .description("description")
        .enabledAnalysisTypes(List.of("enabledAnalysisTypes"))
        .firewallPolicyChangeProtection(false)
        .subnetChangeProtection(false)
        .subnetMappings(List.of(SubnetMappingProperty.builder()
                .subnetId("subnetId")

                // the properties below are optional
                .ipAddressType("ipAddressType")
                .build()))
        .tags(List.of(CfnTag.builder()
                .key("key")
                .value("value")
                .build()))
        .transitGatewayId("transitGatewayId")
        .vpcId("vpcId")
        .build();
csharp
// Install: dotnet add package Amazon.CDK.Lib
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
using Amazon.CDK.AWS.NetworkFirewall;

var cfnFirewall = new CfnFirewall(this, "MyCfnFirewall", new CfnFirewallProps {
    FirewallName = "firewallName",
    FirewallPolicyArn = "firewallPolicyArn",

    // the properties below are optional
    AvailabilityZoneChangeProtection = false,
    AvailabilityZoneMappings = new [] { new AvailabilityZoneMappingProperty {
        AvailabilityZone = "availabilityZone"
    } },
    DeleteProtection = false,
    Description = "description",
    EnabledAnalysisTypes = new [] { "enabledAnalysisTypes" },
    FirewallPolicyChangeProtection = false,
    SubnetChangeProtection = false,
    SubnetMappings = new [] { new SubnetMappingProperty {
        SubnetId = "subnetId",

        // the properties below are optional
        IpAddressType = "ipAddressType"
    } },
    Tags = new [] { new CfnTag {
        Key = "key",
        Value = "value"
    } },
    TransitGatewayId = "transitGatewayId",
    VpcId = "vpcId"
});
go
// Install: go get github.com/aws/aws-cdk-go/awscdk/v2
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
import "github.com/aws/aws-cdk-go/awscdk"

cfnFirewall := awscdk.Aws_networkfirewall.NewCfnFirewall(this, jsii.String("MyCfnFirewall"), &CfnFirewallProps{
	FirewallName: jsii.String("firewallName"),
	FirewallPolicyArn: jsii.String("firewallPolicyArn"),

	// the properties below are optional
	AvailabilityZoneChangeProtection: jsii.Boolean(false),
	AvailabilityZoneMappings: []interface{}{
		&AvailabilityZoneMappingProperty{
			AvailabilityZone: jsii.String("availabilityZone"),
		},
	},
	DeleteProtection: jsii.Boolean(false),
	Description: jsii.String("description"),
	EnabledAnalysisTypes: []*string{
		jsii.String("enabledAnalysisTypes"),
	},
	FirewallPolicyChangeProtection: jsii.Boolean(false),
	SubnetChangeProtection: jsii.Boolean(false),
	SubnetMappings: []interface{}{
		&SubnetMappingProperty{
			SubnetId: jsii.String("subnetId"),

			// the properties below are optional
			IpAddressType: jsii.String("ipAddressType"),
		},
	},
	Tags: []CfnTag{
		&CfnTag{
			Key: jsii.String("key"),
			Value: jsii.String("value"),
		},
	},
	TransitGatewayId: jsii.String("transitGatewayId"),
	VpcId: jsii.String("vpcId"),
})

Initializer ​

ts
new CfnFirewall(scope: Construct, id: string, props: CfnFirewallProps)
python
CfnFirewall(scope: Construct, id: str, props: CfnFirewallProps)
java
new CfnFirewall(Construct scope, String id, CfnFirewallProps props)
csharp
new CfnFirewall(Construct scope, string id, CfnFirewallProps props)
go
NewCfnFirewall(Scope Construct, Id *string, Props CfnFirewallProps)

Construct Props ​

availabilityZoneChangeProtectionboolean | IResolvableavailability_zone_change_protectiontyping.Union[bool, IResolvable]availabilityZoneChangeProtectionBooleanAvailabilityZoneChangeProtectionboolAvailabilityZoneChangeProtectioninterface{}#
A setting indicating whether the firewall is protected against changes to its Availability Zone configuration.

When set to TRUE , you must first disable this protection before adding or removing Availability Zones.

availabilityZoneMappingsIResolvable | IResolvable | CfnFirewall.AvailabilityZoneMappingProperty[]availability_zone_mappingstyping.Union[IResolvable, typing.List[typing.Union[IResolvable, AvailabilityZoneMappingProperty]]]availabilityZoneMappingsIResolvableAvailabilityZoneMappingsIResolvableAvailabilityZoneMappingsinterface{}#
The Availability Zones where the firewall endpoints are created for a transit gateway-attached firewall.

Each mapping specifies an Availability Zone where the firewall processes traffic.

deleteProtectionboolean | IResolvabledelete_protectiontyping.Union[bool, IResolvable]deleteProtectionBooleanDeleteProtectionboolDeleteProtectioninterface{}#
A flag indicating whether it is possible to delete the firewall.

A setting of TRUE indicates that the firewall is protected against deletion. Use this setting to protect against accidentally deleting a firewall that is in use. When you create a firewall, the operation initializes this flag to TRUE .

descriptionstringdescriptionstrdescriptionStringDescriptionstringDescription*string#
A description of the firewall.
enabledAnalysisTypesstring[]enabled_analysis_typestyping.List[str]enabledAnalysisTypesList<String>EnabledAnalysisTypesstring[]EnabledAnalysisTypes*[]*string#
An optional setting indicating the specific traffic analysis types to enable on the firewall.
firewallNamestringfirewall_namestrfirewallNameStringFirewallNamestringFirewallName*stringrequired#
The descriptive name of the firewall.

You can't change the name of a firewall after you create it.

firewallPolicyArnstring | IFirewallPolicyReffirewall_policy_arntyping.Union[str, IFirewallPolicyRef]firewallPolicyArnStringFirewallPolicyArnstringFirewallPolicyArninterface{}required#
The Amazon Resource Name (ARN) of the firewall policy.

The relationship of firewall to firewall policy is many to one. Each firewall requires one firewall policy association, and you can use the same firewall policy for multiple firewalls.

firewallPolicyChangeProtectionboolean | IResolvablefirewall_policy_change_protectiontyping.Union[bool, IResolvable]firewallPolicyChangeProtectionBooleanFirewallPolicyChangeProtectionboolFirewallPolicyChangeProtectioninterface{}#
A setting indicating whether the firewall is protected against a change to the firewall policy association.

Use this setting to protect against accidentally modifying the firewall policy for a firewall that is in use. When you create a firewall, the operation initializes this setting to TRUE .

subnetChangeProtectionboolean | IResolvablesubnet_change_protectiontyping.Union[bool, IResolvable]subnetChangeProtectionBooleanSubnetChangeProtectionboolSubnetChangeProtectioninterface{}#
A setting indicating whether the firewall is protected against changes to the subnet associations.

Use this setting to protect against accidentally modifying the subnet associations for a firewall that is in use. When you create a firewall, the operation initializes this setting to TRUE .

subnetMappingsIResolvable | IResolvable | CfnFirewall.SubnetMappingProperty[]subnet_mappingstyping.Union[IResolvable, typing.List[typing.Union[IResolvable, SubnetMappingProperty]]]subnetMappingsIResolvableSubnetMappingsIResolvableSubnetMappingsinterface{}#
The primary public subnets that Network Firewall is using for the firewall.
notes

Network Firewall creates a firewall endpoint in each subnet. Create a subnet mapping for each Availability Zone where you want to use the firewall.

These subnets are all defined for a single, primary VPC, and each must belong to a different Availability Zone. Each of these subnets establishes the availability of the firewall in its Availability Zone.

In addition to these subnets, you can define other endpoints for the firewall in VpcEndpointAssociation resources. You can define these additional endpoints for any VPC, and for any of the Availability Zones where the firewall resource already has a subnet mapping. VPC endpoint associations give you the ability to protect multiple VPCs using a single firewall, and to define multiple firewall endpoints for a VPC in a single Availability Zone.

tagsCfnTag[]tagstyping.List[CfnTag]tagsList<CfnTag>TagsCfnTag[]Tags*[]CfnTag#
An array of key-value pairs to apply to this resource.

For more information, see Tag .

transitGatewayIdstringtransit_gateway_idstrtransitGatewayIdStringTransitGatewayIdstringTransitGatewayId*string#
The unique identifier of the transit gateway associated with this firewall.

This field is only present for transit gateway-attached firewalls.

vpcIdstring | IVPCRefvpc_idtyping.Union[str, IVPCRef]vpcIdStringVpcIdstringVpcIdinterface{}#
The unique identifier of the VPC where the firewall is in use.

You can't change the VPC of a firewall after you create the firewall.

Properties ​

attrEndpointIdsstring[]attr_endpoint_idstyping.List[str]attrEndpointIdsList<String>AttrEndpointIdsstring[]AttrEndpointIds*[]*stringrequired#
The unique IDs of the firewall endpoints for all of the subnets that you attached to the firewall.

The subnets are not listed in any particular order. For example: ["us-west-2c:vpce-111122223333", "us-west-2a:vpce-987654321098", "us-west-2b:vpce-012345678901"] .

attrFirewallArnstringattr_firewall_arnstrattrFirewallArnStringAttrFirewallArnstringAttrFirewallArn*stringrequired#
The Amazon Resource Name (ARN) of the firewall.
attrFirewallIdstringattr_firewall_idstrattrFirewallIdStringAttrFirewallIdstringAttrFirewallId*stringrequired#
The name of the firewallresource.
attrTransitGatewayAttachmentIdstringattr_transit_gateway_attachment_idstrattrTransitGatewayAttachmentIdStringAttrTransitGatewayAttachmentIdstringAttrTransitGatewayAttachmentId*stringrequired#
The unique identifier of the transit gateway attachment associated with this firewall.

This field is only present for transit gateway-attached firewalls.

availabilityZoneChangeProtectionboolean | IResolvableavailability_zone_change_protectiontyping.Union[bool, IResolvable]availabilityZoneChangeProtectionBooleanAvailabilityZoneChangeProtectionboolAvailabilityZoneChangeProtectioninterface{}#
A setting indicating whether the firewall is protected against changes to its Availability Zone configuration.
availabilityZoneMappingsIResolvable | IResolvable | CfnFirewall.AvailabilityZoneMappingProperty[]availability_zone_mappingstyping.Union[IResolvable, typing.List[typing.Union[IResolvable, AvailabilityZoneMappingProperty]]]availabilityZoneMappingsIResolvableAvailabilityZoneMappingsIResolvableAvailabilityZoneMappingsinterface{}#
The Availability Zones where the firewall endpoints are created for a transit gateway-attached firewall.
CFN_RESOURCE_TYPE_NAMEstringcfn_resource_type_namestrCFN_RESOURCE_TYPE_NAMEStringCFN_RESOURCE_TYPE_NAMEstringCFN_RESOURCE_TYPE_NAME*stringrequiredstatic#
The CloudFormation resource type name for this resource class.
Options for this resource, such as condition, update policy etc.
cfnResourceTypestringcfn_resource_typestrcfnResourceTypeStringCfnResourceTypestringCfnResourceType*stringrequired#
AWS resource type.
creationStackstring[]creation_stacktyping.List[str]creationStackList<String>CreationStackstring[]CreationStack*[]*stringrequired#
deleteProtectionboolean | IResolvabledelete_protectiontyping.Union[bool, IResolvable]deleteProtectionBooleanDeleteProtectionboolDeleteProtectioninterface{}#
A flag indicating whether it is possible to delete the firewall.
descriptionstringdescriptionstrdescriptionStringDescriptionstringDescription*string#
A description of the firewall.
enabledAnalysisTypesstring[]enabled_analysis_typestyping.List[str]enabledAnalysisTypesList<String>EnabledAnalysisTypesstring[]EnabledAnalysisTypes*[]*string#
An optional setting indicating the specific traffic analysis types to enable on the firewall.
firewallNamestringfirewall_namestrfirewallNameStringFirewallNamestringFirewallName*stringrequired#
The descriptive name of the firewall.
firewallPolicyArnstringfirewall_policy_arnstrfirewallPolicyArnStringFirewallPolicyArnstringFirewallPolicyArn*stringrequired#
The Amazon Resource Name (ARN) of the firewall policy.
firewallPolicyChangeProtectionboolean | IResolvablefirewall_policy_change_protectiontyping.Union[bool, IResolvable]firewallPolicyChangeProtectionBooleanFirewallPolicyChangeProtectionboolFirewallPolicyChangeProtectioninterface{}#
A setting indicating whether the firewall is protected against a change to the firewall policy association.
firewallRefFirewallReferencefirewall_refFirewallReferencefirewallRefFirewallReferenceFirewallRefFirewallReferenceFirewallRefFirewallReferencerequired#
A reference to a Firewall resource.
logicalIdstringlogical_idstrlogicalIdStringLogicalIdstringLogicalId*stringrequired#
The logical ID for this CloudFormation stack element.

The logical ID of the element is calculated from the path of the resource node in the construct tree.

To override this value, use overrideLogicalId(newLogicalId).

nodeNodenodeNodenodeNodeNodeNodeNodeNoderequired#
The tree node.
refstringrefstrrefStringRefstringRef*stringrequired#
Return a string that will be resolved to a CloudFormation `{ Ref }` for this element.

If, by any chance, the intrinsic reference of a resource is not a string, you could coerce it to an IResolvable through Lazy.any({ produce: resource.ref }).

stackStackstackStackstackStackStackStackStackStackrequired#
The stack in which this element is defined.

CfnElements must be defined within a stack scope (directly or indirectly).

subnetChangeProtectionboolean | IResolvablesubnet_change_protectiontyping.Union[bool, IResolvable]subnetChangeProtectionBooleanSubnetChangeProtectionboolSubnetChangeProtectioninterface{}#
A setting indicating whether the firewall is protected against changes to the subnet associations.
subnetMappingsIResolvable | IResolvable | CfnFirewall.SubnetMappingProperty[]subnet_mappingstyping.Union[IResolvable, typing.List[typing.Union[IResolvable, SubnetMappingProperty]]]subnetMappingsIResolvableSubnetMappingsIResolvableSubnetMappingsinterface{}#
The primary public subnets that Network Firewall is using for the firewall.
Tag Manager which manages the tags for this resource.
tagsRawCfnTag[]tags_rawtyping.List[CfnTag]tagsRawList<CfnTag>TagsRawCfnTag[]TagsRaw*[]CfnTag#
An array of key-value pairs to apply to this resource.
transitGatewayIdstringtransit_gateway_idstrtransitGatewayIdStringTransitGatewayIdstringTransitGatewayId*string#
The unique identifier of the transit gateway associated with this firewall.
vpcIdstringvpc_idstrvpcIdStringVpcIdstringVpcId*string#
The unique identifier of the VPC where the firewall is in use.

Methods ​

addDeletionOverride(path: string): voiddef add_deletion_override(self, path: str) -> Nonepublic void addDeletionOverride(String path)public void AddDeletionOverride(string path)func AddDeletionOverride(Path *string)#
Syntactic sugar for `addOverride(path, undefined)`.
1 parameter

Parameters

  • pathpathpathpathPath — The path of the value to delete.
addDependency(target: CfnResource): voiddef add_dependency(self, target: CfnResource) -> Nonepublic void addDependency(CfnResource target)public void AddDependency(CfnResource target)func AddDependency(Target CfnResource)deprecated#
Use `addResourceDependency` instead.

This method has been renamed to addResourceDependency to more clearly set it apart from construct.node.addDependency. See the documentation of that function for more details.

addDependsOn(target: CfnResource): voiddef add_depends_on(self, target: CfnResource) -> Nonepublic void addDependsOn(CfnResource target)public void AddDependsOn(CfnResource target)func AddDependsOn(Target CfnResource)deprecated#
Use `addResourceDependency` instead.
notes

This can be used for resources across stacks (or nested stack) boundaries and the dependency will automatically be transferred to the relevant scope.

This method has been renamed to addResourceDependency, which makes it more clear that this method operates at a different level from the construct-level construct.node.addDependency() mechanism.

addMetadata(key: string, value: any): voiddef add_metadata(self, key: str, value: Any) -> Nonepublic void addMetadata(String key, Object value)public void AddMetadata(string key, object value)func AddMetadata(Key *string, Value interface{})#
Add a value to the CloudFormation Resource Metadata.
addOverride(path: string, value: any): voiddef add_override(self, path: str, value: Any) -> Nonepublic void addOverride(String path, Object value)public void AddOverride(string path, object value)func AddOverride(Path *string, Value interface{})#
Adds an override to the synthesized CloudFormation resource.
notes · 2 parameters

To add a property override, either use addPropertyOverride or prefix path with "Properties." (i.e. Properties.TopicName).

If the override is nested, separate each nested level using a dot (.) in the path parameter. If there is an array as part of the nesting, specify the index in the path.

To include a literal . in the property name, prefix with a \. In most programming languages you will need to write this as "\\." because the \ itself will need to be escaped.

For example,

typescript
cfnResource.addOverride('Properties.GlobalSecondaryIndexes.0.Projection.NonKeyAttributes', ['myattribute']);
cfnResource.addOverride('Properties.GlobalSecondaryIndexes.1.ProjectionType', 'INCLUDE');

would add the overrides

json
"Properties": {
  "GlobalSecondaryIndexes": [
    {
      "Projection": {
        "NonKeyAttributes": [ "myattribute" ]
        ...
      }
      ...
    },
    {
      "ProjectionType": "INCLUDE"
      ...
    },
  ]
  ...
}

The value argument to addOverride will not be processed or translated in any way. Pass raw JSON values in here with the correct capitalization for CloudFormation. If you pass CDK classes or structs, they will be rendered with lowercased key names, and CloudFormation will reject the template.

Parameters

  • pathpathpathpathPath — - The path of the property, you can use dot notation to override values in complex types.
  • valuevaluevaluevalueValue — - The value.
addPropertyDeletionOverride(propertyPath: string): voiddef add_property_deletion_override(self, property_path: str) -> Nonepublic void addPropertyDeletionOverride(String propertyPath)public void AddPropertyDeletionOverride(string propertyPath)func AddPropertyDeletionOverride(PropertyPath *string)#
Adds an override that deletes the value of a property from the resource definition.
1 parameter

Parameters

  • propertyPathproperty_pathpropertyPathpropertyPathPropertyPath — The path to the property.
addPropertyOverride(propertyPath: string, value: any): voiddef add_property_override(self, property_path: str, value: Any) -> Nonepublic void addPropertyOverride(String propertyPath, Object value)public void AddPropertyOverride(string propertyPath, object value)func AddPropertyOverride(PropertyPath *string, Value interface{})#
Adds an override to a resource property.

Syntactic sugar for addOverride("Properties.<...>", value).

2 parameters

Parameters

  • propertyPathproperty_pathpropertyPathpropertyPathPropertyPath — The path of the property.
  • valuevaluevaluevalueValue — The value.
addResourceDependency(target: CfnResource, reason?: string): voiddef add_resource_dependency(self, target: CfnResource, reason: typing.Optional[str] = None) -> Nonepublic void addResourceDependency(CfnResource target, String reason)public void AddResourceDependency(CfnResource target, string? reason = null)func AddResourceDependency(Target CfnResource, Reason *string)#
Indicates that this resource depends on another resource and cannot be provisioned unless the other resource has been successfully provisioned.
notes

This can be used for resources across stacks (or nested stack) boundaries and the dependency will automatically be transferred to the relevant scope.

This method only adds dependencies between L1 resources. If you are looking for a generic construct-to-construct dependency mechanism that works for all constructs including L2s, use construct.node.addDependency instead.

applyCrossStackReferenceStrength(strength: ReferenceStrength): voiddef apply_cross_stack_reference_strength(self, strength: ReferenceStrength) -> Nonepublic void applyCrossStackReferenceStrength(ReferenceStrength strength)public void ApplyCrossStackReferenceStrength(ReferenceStrength strength)func ApplyCrossStackReferenceStrength(Strength ReferenceStrength)#
Sets the cross-stack reference strength for this resource.

When set, any cross-stack reference to this resource will use the specified strength instead of the global default from the consuming stack's context.

1 parameter

Parameters

  • strengthstrengthstrengthstrengthStrength — - The reference strength to use for this resource.
applyRemovalPolicy(policy?: RemovalPolicy, options?: RemovalPolicyOptions): voiddef apply_removal_policy(self, policy: typing.Optional[RemovalPolicy] = None, options: typing.Optional[RemovalPolicyOptions] = None) -> Nonepublic void applyRemovalPolicy(RemovalPolicy policy, RemovalPolicyOptions options)public void ApplyRemovalPolicy(RemovalPolicy? policy = null, RemovalPolicyOptions? options = null)func ApplyRemovalPolicy(Policy RemovalPolicy, Options RemovalPolicyOptions)#
Sets the deletion policy of the resource based on the removal policy specified.
notes

The Removal Policy controls what happens to this resource when it stops being managed by CloudFormation, either because you've removed it from the CDK application or because you've made a change that requires the resource to be replaced.

The resource can be deleted (RemovalPolicy.DESTROY), or left in your AWS account for data recovery and cleanup later (RemovalPolicy.RETAIN). In some cases, a snapshot can be taken of the resource prior to deletion (RemovalPolicy.SNAPSHOT). A list of resources that support this policy can be found in the following link:

arnForFirewall(resource: IFirewallRef): string@staticmethod def arn_for_firewall(resource: IFirewallRef) -> strpublic static String arnForFirewall(IFirewallRef resource)public static string ArnForFirewall(IFirewallRef resource)func ArnForFirewall(Resource IFirewallRef) *stringstatic#
cfnPropertyName(cdkPropertyName: string): stringdef cfn_property_name(self, cdk_property_name: str) -> strpublic String cfnPropertyName(String cdkPropertyName)public string CfnPropertyName(string cdkPropertyName)func CfnPropertyName(CdkPropertyName *string) *string#
getAtt(attributeName: string, typeHint?: ResolutionTypeHint): Referencedef get_att(self, attribute_name: str, type_hint: typing.Optional[ResolutionTypeHint] = None) -> Referencepublic Reference getAtt(String attributeName, ResolutionTypeHint typeHint)public Reference GetAtt(string attributeName, ResolutionTypeHint? typeHint = null)func GetAtt(AttributeName *string, TypeHint ResolutionTypeHint) Reference#
Returns a token for an runtime attribute of this resource.

Ideally, use generated attribute accessors (e.g. resource.arn), but this can be used for future compatibility in case there is no generated attribute.

1 parameter

Parameters

  • attributeNameattribute_nameattributeNameattributeNameAttributeName — The name of the attribute.
getMetadata(key: string): anydef get_metadata(self, key: str) -> Anypublic Object getMetadata(String key)public object GetMetadata(string key)func GetMetadata(Key *string) interface{}#
Retrieve a value value from the CloudFormation Resource Metadata.
inspect(inspector: TreeInspector): voiddef inspect(self, inspector: TreeInspector) -> Nonepublic void inspect(TreeInspector inspector)public void Inspect(TreeInspector inspector)func Inspect(Inspector TreeInspector)#
Examines the CloudFormation resource and discloses attributes.
1 parameter

Parameters

  • inspectorinspectorinspectorinspectorInspector — tree inspector to collect and process attributes.
isCfnElement(x: any): boolean@staticmethod def is_cfn_element(x: Any) -> boolpublic static Boolean isCfnElement(Object x)public static bool IsCfnElement(object x)func IsCfnElement(X interface{}) *boolstatic#
Returns `true` if a construct is a stack element (i.e. part of the synthesized cloudformation template).

Uses duck-typing instead of instanceof to allow stack elements from different versions of this library to be included in the same stack.

returns

Returns: The construct as a stack element or undefined if it is not a stack element.

isCfnFirewall(x: any): boolean@staticmethod def is_cfn_firewall(x: Any) -> boolpublic static Boolean isCfnFirewall(Object x)public static bool IsCfnFirewall(object x)func IsCfnFirewall(X interface{}) *boolstatic#
Checks whether the given object is a CfnFirewall.
isCfnResource(x: any): boolean@staticmethod def is_cfn_resource(x: Any) -> boolpublic static Boolean isCfnResource(Object x)public static bool IsCfnResource(object x)func IsCfnResource(X interface{}) *boolstatic#
Check whether the given object is a CfnResource.
isConstruct(x: any): boolean@staticmethod def is_construct(x: Any) -> boolpublic static Boolean isConstruct(Object x)public static bool IsConstruct(object x)func IsConstruct(X interface{}) *boolstatic#
Checks if `x` is a construct.
notes · 1 parameter · returns

Use this method instead of instanceof to properly detect Construct instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the constructs library on disk are seen as independent, completely different libraries. As a consequence, the class Construct in each copy of the constructs library is seen as a different class, and an instance of one class will not test as instanceof the other class. npm install will not create installations like this, but users may manually symlink construct libraries together or use a monorepo tool: in those cases, multiple copies of the constructs library can be accidentally installed, and instanceof will behave unpredictably. It is safest to avoid using instanceof, and using this type-testing method instead.

Parameters

  • xxxxX — Any object.

Returns: true if x is an object created from a class which extends Construct.

obtainDependencies(): Stack | CfnResource[]def obtain_dependencies(self, ) -> typing.List[typing.Union[Stack, CfnResource]]public List<Stack> obtainDependencies()public Stack[] ObtainDependencies()func ObtainDependencies() *[]interface{}#
Retrieves an array of resources and stacks this resource depends on.

For resources depended on directly, returns the CfnResource object. For dependencies on other stacks, returns the Stack object. The order of the array is not guaranteed.

overrideLogicalId(newLogicalId: string): voiddef override_logical_id(self, new_logical_id: str) -> Nonepublic void overrideLogicalId(String newLogicalId)public void OverrideLogicalId(string newLogicalId)func OverrideLogicalId(NewLogicalId *string)#
Overrides the auto-generated logical ID with a specific ID.
1 parameter

Parameters

  • newLogicalIdnew_logical_idnewLogicalIdnewLogicalIdNewLogicalId — The new logical ID to use for this stack element.
removeDependency(target: CfnResource): voiddef remove_dependency(self, target: CfnResource) -> Nonepublic void removeDependency(CfnResource target)public void RemoveDependency(CfnResource target)func RemoveDependency(Target CfnResource)deprecated#
Use `removeResourceDependency` instead

This can be used for resources across stacks (including nested stacks) and the dependency will automatically be removed from the relevant scope.

removeResourceDependency(target: CfnResource): voiddef remove_resource_dependency(self, target: CfnResource) -> Nonepublic void removeResourceDependency(CfnResource target)public void RemoveResourceDependency(CfnResource target)func RemoveResourceDependency(Target CfnResource)#
Indicates that this resource no longer depends on another resource.

This can be used for resources across stacks (including nested stacks) and the dependency will automatically be removed from the relevant scope.

replaceDependency(target: CfnResource, newTarget: CfnResource): voiddef replace_dependency(self, target: CfnResource, new_target: CfnResource) -> Nonepublic void replaceDependency(CfnResource target, CfnResource newTarget)public void ReplaceDependency(CfnResource target, CfnResource newTarget)func ReplaceDependency(Target CfnResource, NewTarget CfnResource)#
Replaces one dependency with another.
2 parameters

Parameters

  • targettargettargettargetTarget — The dependency to replace.
  • newTargetnew_targetnewTargetnewTargetNewTarget — The new dependency to add.
toString(): stringdef to_string(self, ) -> strpublic String toString()public string ToString()func ToString() *string#
Returns a string representation of this construct.
returns

Returns: a string representation of this resource

with(...mixins: IMixin[]): IConstructdef with(self, mixins: IMixin) -> IConstructpublic IConstruct with(IMixin mixins)public IConstruct With(IMixin mixins)func With(Mixins IMixin) IConstruct#
Applies one or more mixins to this construct.

Mixins are applied in order. The list of constructs is captured at the start of the call, so constructs added by a mixin will not be visited. Use multiple with() calls if subsequent mixins should apply to added constructs.